
;**********************************************************************
;	t@CFPreSC.asm			2022.05.10	 /2022.07.04 
;     TD7104vXP[@\tg                    jk1xkp
;**********************************************************************
;      Qlā@Ek29Nor.asm  	gp
;	
;	ohb		PIC12F629   assembler ;MPLAB
;  gJE^@o
;
;		NbN	4MHz;

;sATCFidE̔z͏ȗj
;		
;	PIC12F629	
;	sATC
;	GP0(07)				TD7104 Pin N2
;	GP1(06)				TD7104 Pin N1
;	GP2(05)				LED Control
;	GP3(04)				Tact SW
;	GP4(03)				Prscaler 1/10
;	GP5(02)			=   RF miliVal H/L display
;**********************************************************************

	list      p=12f629           ; list directive to define processor
	#include <p12f629.inc>        ; processor specific variable definitions

	errorlevel  -302              ; suppress message 302 from list file

	__CONFIG   _CP_OFF & _CPD_OFF & _BODEN_ON & _MCLRE_OFF & _WDT_OFF & _PWRTE_ON &_INTRC_OSC_NOCLKOUT     

; '__CONFIG' directive is used to embed configuration word within .asm file.
; The lables following the directive are located in the respective .inc file.
; See data sheet for additional information on configuration word settings.

#define		Tact   	GPIO,3		;;Tact SW
;***** VARIABLE DEFINITIONS
;    ------------- adress 20&H
w_temp        EQU     0x20        ; variable used for context saving 
status_temp   EQU     0x21        ; variable used for context saving
wait_cn		EQU	H'22'
wait_cn2	EQU	H'23'
cs			EQU	H'24'	;EEPROM Saveł̎ԃJEg@>100łr
cn			EQU	H'25'
wt_cn		EQU	H'26'	;TactSW ONiGP5controlj Time Base
wt_cn2		EQU	H'27'	;TactSW ONiGP5controlj Time Base
poi     	EQU	H'28'
N1N2		EQU	H'29'	;GP Out for TD7104 N1, N2
N1N2sp		EQU	H'2a'	;Spare for N1N2
wt_stb		EQU	H'2b'	;
scn			EQU	H'2c'	;EEPROM Data@Af[^
oldNum		EQU	H'2d'	;
stROM		EQU	H'2e'	;EEPROM Data EEPROM #0Ԓn
Num			EQU	H'2f'	;0`9@0=1/1, 1=1/2, 2=1/4, 3=1/8, 4=1/10 5,6,7=None//EEPROM Data EEPROM #1Ԓn
;    ------------- adress 30&H
ct10		EQU	H'30'	;1/10 vXṔ@10counter (8:2GP4)
Histsave	EQU	H'31'	;if Histsave,0=1  , Num been saved
Nnew		EQU	H'32'	;荞݁ANum change@Nnew=1
Delay		EQU	H'33'	;if Delay=1A20msec 80msec ̍̕␳
;    ------------- adress 40&H
;    ------------- adress 50&H
 
;    ------------- adress END H'5F'
;**********************************************************************
		ORG     0x000             ; processor reset vector
		goto    start              ; go to beginning of program

		ORG     0x004             ; interrupt vector location
		movwf   w_temp            ; save off current W register contents
		movf	STATUS,w          ; move status register into W register
		movwf	status_temp       ; save off contents of STATUS register
; isr code can go here or be located as a call subroutine elsewhere
		bcf		INTCON,7		;荞݋֎~
		btfsc	Tact
		goto	iout

		call	wait_2	;wait for 2msec
		btfsc	Tact
		goto	iout

		call	wait_2	;wait for 2msec
		btfsc	Tact
		goto	iout
	;---------
Num_chg		;0`7@0=1/1, 1=1/2, 2=1/4, 3=1/8, 4=1/10 5,6,7=None
		incf	Num,1	;Num= Num+1 (0<= Num <=7)
		movf	Num,0
		sublw	D'9'	;W=9+(256-Num)
		movlw	D'0'	
		btfsc	STATUS,C	;;if Num=>10, then C=0 & Num=0
		movf	Num,0
		movwf	Num
		goto	setTD	;setting nr0, nr1, het
;------------
setTD	bcf     STATUS,RP0        ; set file register bank to 0
		movf	Num,0
		call	P_data ;;setting TD7104 N1, N2
		movwf	N1N2
		movwf	N1N2sp
		movwf	GPIO
		movlw	D'1'
		movwf	Nnew
;------------

iout	btfss	Tact
		goto	iout
		clrf	Histsave ;if Histsave=0 ,then saved after cs=100
		clrf	cs
		bcf		INTCON,0	;clr GPIF: Port Change Interrupt Flag bit
		bsf		INTCON,7
		movf    status_temp,w     ; retrieve copy of STATUS register
		movwf	STATUS            ; restore pre-isr STATUS register contents
		swapf   w_temp,f
		swapf   w_temp,w          ; restore pre-isr W register contents
		retfie                    ; return from interrupt
; remaining code goes here
;----------------------------------------------------------------------------
;==========================
P_data	addwf	PCL,1	; 0`7@0=1/1, 1=1/2, 2=1/4, 3=1/8, 4=1/10 5,6,7=None
		retlw	B'00010100'		;poi=0, 1/1 LED-N1-N2 /D5=OFF
		retlw	B'00010110'		;poi=1, 1/2	LED-N1-N2 /D5=OFF
		retlw	B'00010001'		;poi=2, 1/4	LED-N1-N2 /D5=OFF
		retlw	B'00010011'		;poi=3, 1/8	LED-N1-N2 /D5=OFF
		retlw	B'10010111'		;poi=4, 1/10	LED-Sď;bit7=1/10Flag

		retlw	B'00110100'		;poi=5, 1/1 LED-N1-N2 /D5=ON
		retlw	B'00110110'		;poi=6, 1/2	LED-N1-N2 /D5=ON
		retlw	B'00110001'		;poi=7, 1/4	LED-N1-N2 /D5=ON
		retlw	B'00110011'		;poi=8, 1/8	LED-N1-N2 /D5=ON
		retlw	B'10110111'		;poi=9, 1/10	LED-Sď;bit7=1/10Flag
		
		retlw	B'00010100'		;poi=10, 1/1 LED-N1-N2 /D5=OFF
		retlw	B'00010110'		;poi=11, 1/2	LED-N1-N2 /D5=OFF
		retlw	B'00010001'		;poi=12, 1/4	LED-N1-N2 /D5=OFF
		retlw	B'00010011'		;poi=13, 1/8	LED-N1-N2 /D5=OFF
		retlw	B'10010111'		;poi=14, 1/10	LED-Sď;bit7=1/10Flag
		retlw	B'00110100'		;poi=15, 1/1 LED-N1-N2 /D5=ON
	;  ----------------------------------------------
start	call    0x3FF             ; retrieve factory calibration value
		bsf     STATUS,RP0        ; set file register bank to 1
		movwf   OSCCAL            ; update register with factory cal value 
		bcf     STATUS,RP0        ; set file register bank to 0

		movlw	B'00010100'	
		movwf	N1N2

		call	wait_255

		movlw	B'00001000'		;
		movwf	INTCON

		bsf    	STATUS,RP0	;oN1
		movlw	B'00000000'		;GIOvAbvEnable; ;TMR0 prescaler 1:2 set ;	
		movwf	OPTION_REG	

		movlw	B'00001000'		 ;GPIO 5,4,2,1,0-Output ,3;input
		movwf	TRISIO
		movwf	IOC			;荞݁@GP3ݒ	

		movlw	B'00000000'		;GP4-1 EB[NEvAbv  PullUp disable
		movwf	WPU
		bcf    	STATUS,RP0	;oN0
		clrf	GPIO

		movlw	D'0'	; Num=0
		movwf	Num 
		movwf	oldNum 		

		movlw	H'1'
		movwf	stROM
		clrf	cs
		clrf	Histsave
		bsf		Histsave,0
		clrf	Delay
		bsf		Delay,0

st05	call	load_1st
		movlw	B'00000001'
		subwf	stROM,0	 
		btfss	STATUS,Z	;if stROM=1, then st07 & Load_m else atart1
		goto	start1

st08	call	load_m		;EEPROM #0(mode) &01h-o5hԒnload
							;stROM, Num,	nr0,	nr1,	Nband- 5A
		movlw	B'00001111'
		andwf	Num,0
		movwf	Num
		movwf	oldNum
		movf	stROM,1	; if stROM=0, then init EEPROM save(sav_ini)
		btfss	STATUS,Z
		goto	start3
	
start1	movlw	H'1'	;===; Num̏EEPROMւ save
		movwf	stROM ;stROM=1
		clrf	Num
		clrf	oldNum
		clrf	ct10
		call	P_data
		movwf	N1N2
		movwf	GPIO
		call 	sav_ini	;===; Num̏EEPROMւ save
		goto	main

start3	movf	Num,0
		call	P_data
		movwf	N1N2
		movwf	GPIO

main	
main5	bsf		INTCON,7 ;荞݊Jn
		btfsc	N1N2,7		;if N1N2.7=1, then goto 8:2 mode (1/10) & LED(GP2)_
		goto	main74
		goto	main54

			;;===(Normal mode)==== 25bi0.25bx cs;100j@ωȂ΁ANum Save ========
main54	call	wait_255

main55	movf	Histsave,1 ;if Histsave=0 ,then saved after cs=100	
		btfss	STATUS,Z
		goto	main8
		
main57	incf	cs,1
		movlw	D'100'	;EEPROM Save҂ԁ@D100x0.255b
		subwf	cs,0	;W=cs+i256-100j
		btfss	STATUS,C 
		goto	main5

		bcf		INTCON,7 ;荞ݒ~
		call	Memo		;EEPROM̂Ł@KvŒɁII 
		bsf		Histsave,0 ;if Histsave=1 ,then not saved after cs=100
		goto	main8
			 ;;======= 25b@ωȂ΁ANum Save ========܂

			;;===(1/10mode)==== 25bi0.25bx cs;100j@ωȂ΁ANum Save ========
main74	bsf		Delay,0		;if Delay=1A20msec 80msec ̍̕␳
		call	stb_255

main75	movf	Histsave,1 ;if Histsave=0 ,then saved after cs=100	
		btfss	STATUS,Z
		goto	main8
		
main77	incf	cs,1
		movlw	D'100'	;EEPROM Save҂ԁ@D100x0.255b
		subwf	cs,0	;W=cs+i256-100j
		btfss	STATUS,C 
		goto	main5

		bcf		INTCON,7 ;荞ݒ~
		call	Memo		;EEPROM̂Ł@KvŒɁII 
		bsf		Histsave,0 ;if Histsave=1 ,then not saved after cs=100
		goto	main8
			 ;;======= 25b@ωȂ΁ANum Save ========܂


main8	clrf	cs
		goto	main

;    ---------------------------------------------------
load_1st
		bsf		STATUS,RP0		;Bank1
		movlw	H'0'
		movwf	EEADR
		movlw	D'1'      
		movwf	scn

		movlw	stROM   ;stROM, Num- 2address  
		movwf	FSR
		goto	load_rt
;	;------------------------
;		;#00h   #01h    
;		;stROM, Num,	
load_m	bsf		STATUS,RP0		;Bank1
		movlw	H'0'
		movwf	EEADR

		movlw	D'2'      
		movwf	scn

		movlw	stROM   ;stROM, Num  2address  
		movwf	FSR
load_rt	bsf		STATUS,RP0	;Bank1/Select Bank of EEADR
		bsf		EECON1,RD		; EE Read
		movf	EEDATA,0      
		movwf	INDF

		incf	EEADR,1		; Data Memory Address to read
		incf	FSR,1
		decfsz	scn,1
		goto	load_rt

		bcf		STATUS,RP0	;Bank0
		return
;    ------------------------------------
;    ------------------------------------
Memo
sav_ini		;
		bsf		STATUS,RP0		;Bank1
		movlw	H'0'
		movwf	EEADR
		movlw	D'2'      
		movwf	scn

		movlw	stROM   ;stROM, Num,- 2Aaddress
		movwf	FSR
sav_i5	movf	INDF,W
		movwf	EEDATA
		call	datawrite

		bsf		STATUS,RP0		;Bank1
		incf	EEADR,1
		incf	FSR,1
		decfsz	scn,1
		goto	sav_i5
		bcf		STATUS,RP0	;Bank0/
		bsf		INTCON,GIE 		; Enable INTs.
		return
;   ----------------------------------------		
datawrite	
		bsf		STATUS,RP0	;Bank1/	Select Bank of EECON1
		bsf		EECON1,WREN		;WRENޯ on; Enable writes
		bcf		INTCON,GIE 		; Disable INTs
	;-----
		movlw	H'55'
		movwf	EECON2
		movlw	H'aa'
		movwf	EECON2
		bsf		EECON1,WR 		; Set WR bit to begin write
	;-----
	;	bsf		INTCON,GIE 		; Enable INTs.

		call	wt15ms		; wait 15ms
		bcf		STATUS,RP0	;Bank0/
		return
;**********************************************************************
stb_255		btfss	N1N2,2
			goto	stb_H
			bcf		N1N2,2	;GP2 L (LED D4 ON)
			goto	stb_s
stb_H		bsf		N1N2,2		;GP2 H (LED D4 OFF)		

stb_s		movlw	D'3'		;(D'2' +D'8') x D'25'@=250
			movwf	wt_stb			

stb_ms		bcf		N1N2,4		;GP4 L@TD7104 stanby
			movf	N1N2,0
			movwf	GPIO
			movlw	D'20'		;2000usec x10  
			movwf	wt_cn		;
			movf	Delay,1  	;if Delay=0, skip nop/ goto stb_ms5
			btfsc	STATUS,Z
			goto	stb_ms5

			clrf	Delay
			nop
			nop	
			nop
			nop
			nop	
			nop
			nop
			nop
			nop	
			nop

stb_ms5		call	wt_ms

			bsf		N1N2,4		;GP4 H= TD7104@work
			movf	N1N2,0
			movwf	GPIO
			movlw	D'80'			;8000sec x10 +
			movwf	wt_cn
			nop
			nop
			nop
			nop	

			call	wt_ms

		btfsc	Nnew,0
		goto	stb_end

		decfsz	wt_stb,1				;djnz	wait_cn2,wait_ms1
		goto	stb_ms
		return

stb_end	movf	N1N2sp,0
		movwf	N1N2
		movwf	GPIO
		clrf	Nnew
		return				

;---------------------------------------------------------------------------------
;		I[_[̃EFCg@@mode 1/10p(   
;
wt_255		movlw	D'255'			;mov	wait_cn,#255
			movwf	wt_cn
			goto	wt_ms
wt_ms  
		
wt_ms0
			movlw	D'200'			;mov	wait_cn2,#0
			movwf	wt_cn2
wt_ms1
		nop
		nop
		decfsz	wt_cn2,1				;djnz	wait_cn2,wait_ms1
		goto	wt_ms1
	;===== TD7104 stanby Pin8  8(H)F2(L)
	;	incf	ct10,1
	;	movf	ct10,0
	;	sublw	D'10'	;W=10 +(256-ct10)
	;	movlw	D'0'	
	;	btfss	STATUS,Z
	;	movf	ct10,0
	;	movwf	ct10

	;	bcf     STATUS,RP0        ; set file register bank to 0	
	;	btfss	ct10,3   ; ct10=H'8'=B'00001000'/ if ct10,3=1, then TD7104 stan-by
	;	bsf		N1N2,4		;GP4 H
	;	btfsc	ct10,3   ; ct10=H'8'=B'00001000'
	;	bcf		N1N2,4		;GP4 L
	;	movf	N1N2,0
	;	movwf	GPIO
		nop
	;	btfsc	Nnew,0
	;	goto	wt_end

	;===== TD7104 stanby Pin8  8(H)F2(L)    ܂ŁB
		decfsz	wt_cn,1				;djnz	wait_cn,wait_ms0
		goto	wt_ms0
		return

wt_end	;movf	N1N2sp,0
		;movwf	N1N2
		;movwf	GPIO
		;clrf	Nnew
		;return

;---------------------------------------------------------------------------------
;		I[_[̃EFCg@@;
wait_255	movlw	D'255'			;mov	wait_cn,#255
			movwf	wait_cn
			goto	wait_ms

wt15ms		movlw	D'15'	;mov	wait_cn,#15
			movwf	wait_cn
			goto	wait_ms

wait_2		movlw	D'2'			;mov	wait_cn,#20
			movwf	wait_cn
wait_ms  				
		
wait_ms0
			movlw	D'0'			;mov	wait_cn2,#0
			movwf	wait_cn2
wait_ms1
	;	nop
	;	nop
	;;	nop
	;	nop
		nop
		nop
		decfsz	wait_cn2,1				;djnz	wait_cn2,wait_ms1
		goto	wait_ms1	
		decfsz	wait_cn,1				;djnz	wait_cn,wait_ms0
		goto	wait_ms0
		return

;
;		ʂI[_[̃EFCg
wait_50uS	movlw	D'50'			;mov	wait_cn,#255
			movwf	wait_cn
			goto	wait_us
;
wait_us
wait_us0
		decfsz	wait_cn,1			;djnz	wait_cn,wait_us0
		goto	wait_us0
		return

        END                       ; directive 'end of program'
;------------------------------------------------
; initialize eeprom locations
		ORG	0x2100
		DE	0x00, 0x01, 0x02, 0x03


		END                      



